=== modified file 'qml/Shell.qml'
--- qml/Shell.qml	2016-04-21 13:47:29 +0000
+++ qml/Shell.qml	2016-04-28 11:24:24 +0000
@@ -496,7 +496,8 @@
             launcher.fadeOut();
         }
 
-        if (!greeter.locked && ApplicationManager.focusedApplicationId != "unity8-dash") {
+        if (!greeter.locked && tutorial.launcherLongSwipeEnabled
+            && ApplicationManager.focusedApplicationId != "unity8-dash") {
             ApplicationManager.requestFocusApplication("unity8-dash")
             launcher.fadeOut();
         }

=== modified file 'qml/Tutorial/Tutorial.qml'
--- qml/Tutorial/Tutorial.qml	2015-11-13 21:54:42 +0000
+++ qml/Tutorial/Tutorial.qml	2016-04-28 11:24:24 +0000
@@ -37,6 +37,7 @@
     property int lastInputTimestamp
 
     readonly property bool launcherEnabled: loader.item ? loader.item.launcherEnabled : true
+    readonly property bool launcherLongSwipeEnabled: loader.item ? loader.item.launcherLongSwipeEnabled : true
     readonly property bool spreadEnabled: loader.item ? loader.item.spreadEnabled : true
     readonly property bool panelEnabled: loader.item ? loader.item.panelEnabled : true
     readonly property bool running: loader.item ? loader.item.running : false

=== modified file 'qml/Tutorial/TutorialContent.qml'
--- qml/Tutorial/TutorialContent.qml	2016-04-28 10:44:17 +0000
+++ qml/Tutorial/TutorialContent.qml	2016-04-28 11:24:24 +0000
@@ -33,9 +33,12 @@
     readonly property bool launcherEnabled: !running
                                             || tutorialLeftLoader.shown
                                             || tutorialLeftLongLoader.shown
+    readonly property bool launcherLongSwipeEnabled: tutorialLeftLongLoader.shown
+                                                     || tutorialLeftLongLoader.skipped
     readonly property bool spreadEnabled: !running || tutorialRightLoader.shown
     readonly property bool panelEnabled: !running || tutorialTopLoader.shown
     readonly property bool running: tutorialLeftLoader.shown
+                                    || tutorialLeftLongLoader.shown
                                     || tutorialTopLoader.shown
                                     || tutorialRightLoader.shown
 

=== modified file 'tests/qmltests/Tutorial/tst_Tutorial.qml'
--- tests/qmltests/Tutorial/tst_Tutorial.qml	2016-04-28 10:44:17 +0000
+++ tests/qmltests/Tutorial/tst_Tutorial.qml	2016-04-28 11:24:24 +0000
@@ -309,6 +309,18 @@
             tryCompare(tutorialTop, "opacity", 1);
         }
 
+        function openTutorialLeftLong() {
+            var tutorialLeftLong = findChild(shell, "tutorialLeftLong");
+            var tutorialLeftLongTimer = findChild(tutorialLeftLong, "tutorialLeftLongTimer");
+
+            AccountsService.demoEdgesCompleted = ["left", "top"];
+            ApplicationManager.startApplication("gallery-app");
+
+            tutorialLeftLongTimer.interval = 1;
+            tryCompare(tutorialLeftLong, "shown", true);
+            tryCompare(tutorialLeftLong, "opacity", 1);
+        }
+
         function openTutorialRight() {
             var tutorialLeftLoader = findChild(shell, "tutorialLeftLoader");
             var tutorialRight = findChild(shell, "tutorialRight");
@@ -414,6 +426,24 @@
             tryCompare(AccountsService, "demoEdgesCompleted", ["left"]);
         }
 
+        function test_tutorialLongLeftSwipeDisabled() {
+            // Test that a long left swipe is disabled until we get to or pass
+            // the long left tutorial.
+            var tutorial = findChild(shell, "tutorial");
+
+            verify(!tutorial.launcherLongSwipeEnabled);
+
+            openTutorialLeftLong();
+            verify(tutorial.launcherLongSwipeEnabled);
+
+            openTutorialRight();
+            verify(tutorial.launcherLongSwipeEnabled);
+
+            AccountsService.demoEdges = false;
+            tryCompare(tutorial, "running", false);
+            verify(tutorial.launcherLongSwipeEnabled);
+        }
+
         function test_tutorialTopEdges() {
             var tutorial = findChild(shell, "tutorial");
             var tutorialTop = findChild(tutorial, "tutorialTop");

